;;; -*- Mode:Common-Lisp; Package:User; Base:10; Fonts: CPTFONT,HL12,HL12BI,CPTFONTB -*-

1;;;*		2"Almost Scheme"
1;;;
;;;   **	1An implementation of Scheme running on top of* 1TI Explorer Common Lisp.
;;;
;;;*	1See file *"GUIDE.TEXT"1 for operating instructions.

;;; Copyright (C) 1987,1988 Texas Instruments Incorporated. All rights reserved.

;; Revised:
;;  2/20/88 DNG - Added file *"optimize"1.
;;  3/21/88 DNG - Added file *"guide.text"1.
;;  3/31/88 DNG - Added file *"pnum2s"1.
;;  4/13/88 DNG - Added system *"SCHEME-RUNTIME"1.
;;  4/16/88 DNG - Added files *"structure" 1and* "debug".
1;;  4/22/89 DNG - Removed obsolete file *"fix-6159"1.  Added file *"print"1.*


(DEFSYSTEM SCHEME
  (:NAME "Almost Scheme")
  1;;  Default to whatever directory this file is being read from.*
  (:PATHNAME-DEFAULT #.(namestring (send sys:fdefine-file-pathname :new-pathname
					 :name nil :type nil :version nil))) 
  (:MODULE DEFS ("scheme3"))	1; Scheme as per Revised^3 Report*
  (:MODULE MODE ("mode"		1; Scheme *lisp-mode1 and Zmacs patches*
		 "readtable"	1; Scheme read table*
		 "windows"	1; Simulate PC Scheme windows*
		 ;;"macros"	1; definitions not needed for running compiled code*
		 ))
  1;; The next group uses the mode macros.*
  (:MODULE EVAL ("pcs"		1; PC Scheme compatibility features*
		 "eval"		1; Evaluator patches*
		 "compiler"	1; Compiler patches*
		 "ucl"		1; patch UCL error checking*
		 "mit"		1; Compatibility features for MIT Scheme and/or Pseudoscheme*
		 "debug"	1; PC Scheme debug tools*
	  #+CLOS "print"	1;* print-object 1patches*
		 ))
  (:MODULE MORE ("optimize"	1; Compiler optimizers and style checkers*
		 ))
  (:MODULE FINAL ("in-scheme"	1; functions implemented in Scheme*
		  "structure"	1; macros implemented in Scheme*
		  "pnum2s"	1; 3number->string**
		  ))
  (:MODULE INFO ("guide.text" "status.text")) ; 1user documentation files*
  (:COMPILE-LOAD DEFS)
  (:COMPILE-LOAD MODE (:FASLOAD DEFS))
  (:COMPILE-LOAD EVAL (:FASLOAD DEFS MODE))
  (:COMPILE-LOAD MORE (:FASLOAD DEFS MODE EVAL))
  (:COMPILE-LOAD FINAL (:FASLOAD DEFS MODE EVAL MORE))
  (:AUXILIARY INFO)
 )

1;; Load the following system instead if you just want to run previously compiled
;; Scheme programs and will not be evaluating, compiling, or editing Scheme source
;; code.*
(DEFSYSTEM SCHEME-RUNTIME
  (:PATHNAME-DEFAULT #.(namestring (send sys:fdefine-file-pathname :new-pathname
					 :name nil :type nil :version nil))) 
  (:MODULE DEFS ("scheme3"))	1; Scheme as per Revised^3 Report*
  (:MODULE MODE ("readtable"	1; Scheme read table*
		 "windows"	1; Simulate PC Scheme windows*
		 ))
  (:MODULE EVAL ("pcs"		1; PC Scheme compatibility features*
	  #+CLOS "print"	1;* print-object 1patches*
		  ))
  (:MODULE FINAL ("in-scheme"	1; functions implemented in Scheme*
		  "pnum2s"	1; 3number->string**
		  ))
  (:FASLOAD DEFS)
  (:FASLOAD MODE (:FASLOAD DEFS))
  (:FASLOAD EVAL (:FASLOAD DEFS MODE))
  (:FASLOAD FINAL (:FASLOAD DEFS MODE EVAL))
 )